/*
	Useful GPU routines for 68000 and GPU
*/

	.68000
/*
	Load data into gpu
	input:
		a0 gpu code:
		d0 code length in bytes
		a1 destination in gpu ram
*/
LoadGPU
	lea	$f02110,a2
	move.l #$3E00,-$10(a2)		// GPU flags
	moveq #0,d1
	move.l d1,4(a2)				// GPU halt
	move.l a1,(a2)				// set pc to data loaded
	lsr.l #2,d0
.copy
	move.l (a0)+,(a1)+
	dbra d0,.copy
	rts

/*
	Run GPU, all registers and code must be already set
*/
GoGPU
	move.l #1,$f02114	// Go
	rts

/*
	Wait for a GPU code to finish, all registers and code must be already set
*/
WaitGPU
	stop #$2000
	move.l $f02114,d0
	btst #0,d0
	bne.s WaitGPU
	rts


